<?php
namespace AppBundle\Model\SubsFormat;

/**
 * srtFormat.class.php
 *
 * Class to work with .srt files.
 *
 * @package PHP srtFormat;
 * @category Subtitles
 * @author Víctor Hernández Torner
 * @copyright 2017 Víctor Hernández Torner
 * @license https://opensource.org/licenses/GPL-3.0 GNU General Public License 3.0
 * @version 1.0
 * 
 */

/**
 * Class xmlFormat
 *
 * @package SubsFormat
 *
 */


class Subtitle{

    private $id;
    private $tcIn;
    private $tcOut;
    private $text;
    private $italic;


    public function __construct($id, $tcIn, $tcOut, $text, $italic) {
        $this->id = $id;
        $this->tcIn = $tcIn;
        $this->tcOut = $tcOut;
        $this->text = $text;
        $this->italic = $italic;


       /*
        $this->id = $this->setId($id);
        $this->tcIn = $this->setTcIn($tcIn);
        $this->tcOut = $this->setTcOUt($tcOut);
        $this->text = $this->setText($text);
        $this->italic = $this->setItalic($italic);
        */
    }

    public function getId(){
        return $this->id;
    }

    public function setId($id){
        $this->id = $id;
    }

    public function getTcIn(){
        return $this->tcIn;
    }

    public function setTcIn($tcIn){
        $this->tcIn = $tcIn;
    }

    public function getTcOut(){
        return $this->tcOut;
    }

    public function setTcOut($tcOut){
        $this->tcOut = $tcOut;
    }

    public function getText(){
        return $this->text;
    }

    public function setText($text){
        $this->text = $text;
    }

    public function getItalic(){
        return $this->italic;
    }

    public function setItalic($italic){
        $this->italic = $italic;
    }
}


