//Javascript document     

$(document).ready(function(){

    /* SHOW CONTENT ONLY WHEN PAGE IS READY*/
    $('#all').show();

    /*EDITOR SHOW ITALIC*/

  	$('.italicCkeck').each(function(index) {
      	if($(this).is(':checked')) {
      		$(this).parent().siblings().has('textarea').toggleClass('cursiva');
          $('#textOriginalExport'+$(this).attr('id')).addClass('cursiva');
          $('#textTranslateExport'+$(this).attr('id')).addClass('cursiva');
      	}	
    });


    $('.italicCkeck').change(function() {
      if($(this).is(':checked')) {
        $(this).parent().siblings().has('textarea').addClass('cursiva');
        $('#textOriginalExport'+$(this).attr('id')).addClass('cursiva');
        $('#textTranslateExport'+$(this).attr('id')).addClass('cursiva');
      }    
      else{
        $(this).parent().siblings().has('textarea').removeClass('cursiva');
        $('#textOriginalExport'+$(this).attr('id')).removeClass('cursiva');
        $('#textTranslateExport'+$(this).attr('id')).removeClass('cursiva');
      }
     }); 
    
   /*EXPORT SUBS SHOW HIGHLIGHT*/

  $('.highlightCkeck').change(function() {
    if($(this).is(':checked')) {
      $(this).parent().parent().addClass('backgroundHighlight');
    } else {
      $(this).parent().parent().removeClass('backgroundHighlight');
    }
  });



    /* TRANSLATE AJAX  + CONTROL BUTTON ERASE TRANSLATION*/

    $( "#translate" ).click(function() {

        $totalSubs =  $(".textOriginal").length;
        $(".textOriginal").each(function(index) {
            var text = $(this).val();
            var targetLang = $('select[name=targetLang]').val();
            var sourceLang = $('select[name=sourceLang]').val();
            var URL = Routing.generate('ajaxtranslate');
            var lastItem = false;
            if (index == $totalSubs - 1)  lastItem = true;
            $.ajax({  
                url: URL,
                context: this,
                data: { 
                    sl: sourceLang,
                    tl: targetLang,
                    q: text,
                    lastItem : lastItem,
                },
                dataType: 'json',
                success: function(json) {
                    $('#textTranslate'+(index+1)).val(json.trans);
                    if (json.lastItem == 'true') {
                       alert('TRANSLATION HAS FINISHED!');
                    }                 },
                error : function(jqXHR, status, error) {
                    alert('¡Api Error! Plese, try later.');
                },
            });
          });
      });

      $("#eraseTranslate").click(function() {
      if (confirm('The system will erase all translated subs. Are You sure?')) {
        $('.textTranslate').each(function(index) {
         $(this).val('');
        }); 
      }
    });

    /* TOOGLE TRANSLATION CHECKBOX */ 

  	$("#toogleTranslate").click(function() {
  		$('#translateInfo').toggle();
  		$('#thTraduccio').toggleClass('gris');

      if($('#thTraduccio').hasClass('gris')) {
    		$('.textTranslate').each(function(index) {
            $(this).prop("disabled", true);
        });	
      } else {
        $('.textTranslate').each(function(index) {
            $(this).prop("disabled", false);
        }); 
      }
    }); 



  	/* MAIN BUTTONS & UPDATE INFO IN HIGHLIGHT SUBTITLES LIST */	

  	$(".mainExSubs , .mainExText, .mainInfo").hide();


    $("#fileBut").on("click", function(){ 
      $(this).addClass("colorfons");
      $("#editBut, #exportTextBut, #exportSubsBut").removeClass("colorfons");
      $(".mainEdit").hide();
      $(".mainExText").hide();
      $(".mainExSubs").hide();
      $(".mainInfo").show();
     });  

    $("#editBut").on("click", function(){	
      $(this).addClass("colorfons");
			$("#exportSubsBut, #exportTextBut, #fileBut").removeClass("colorfons");
			$(".mainExSubs").hide();
			$(".mainExText").hide();
      $(".mainInfo").hide();
			$(".mainEdit").show();
     });	

  	$("#exportSubsBut").on("click", function(){	
      $(this).addClass("colorfons");
			$("#editBut, #exportTextBut, #fileBut").removeClass("colorfons");
			$(".mainEdit").hide();
			$(".mainExText").hide();
      $(".mainInfo").hide();
			$(".mainExSubs").show();
     });	

  	$("#exportTextBut").on("click", function(){
      $(this).addClass("colorfons");
			$("#exportSubsBut, #editBut, #fileBut").removeClass("colorfons");
			$(".mainEdit").hide();
			$(".mainExSubs").hide();
      $(".mainInfo").hide();
			$(".mainExText").show();

			if($('#highLightCheck').is(':checked')) 
      {
  			$(".textOriginal").each(function(index) {
  				var texto = $(this).val();
          texto = texto.replace(new RegExp("\n","g"), "<br>");
  				$('#textOriginalExport'+(index+1)).empty().html(texto);

  			});

			$(".textTranslate").each(function(index) {
				var texto = $(this).val();
        texto = texto.replace(new RegExp("\n","g"), "<br>");
				$('#textTranslateExport'+(index+1)).empty().html(texto);
			});

    	$('#tableList').show();
      }	

		  });	



    /* SHOW & HIDE HIGHLIGHTS LIST*/                                                       

  	$('#highLightCheck').click(function() {
  		if($(this).is(':checked')) {
  			$(".textOriginal").each(function(index) {
  				var texto = $(this).val();
          texto = texto.replace(new RegExp("\n","g"), "<br>");
  				$('#textOriginalExport'+(index+1)).empty().html(texto);
  			});

  			$(".textTranslate").each(function(index) {
  				var texto = $(this).val();
          texto = texto.replace(new RegExp("\n","g"), "<br>");
  				$('#textTranslateExport'+(index+1)).empty().html(texto);
  			});
      		$('#tableList').show();
           $('#highlightAlert').addClass('alert alert-info').text('Use the scroll in the window to navigate through the subtitle list');
      	} else {
      		$('#tableList').hide();
          $('#highlightAlert').removeClass('alert alert-info').empty();
      	}
  	}); 
    

  	
    /* SHOW & HIDE FIELDS WHEN CHANGE TEXT FORMAT*/

    $('#highlight, #downLoadButtonText, #tableList, #columnTranslationText' ).hide();

  	$( "select[name=textFileType]" ).change(function() {
				if(this.value != "nothing") 
				{
					if(this.value != 'csv') 
					{
					$('#highlight').show();
					$('#downLoadButtonText').show();
          $('#columnTranslationText').show();
          $('#tableList').hide();

          $('#highLightCheck').prop("checked", "");
          $('#exportTranslation').prop("checked", "");
					} 
					else
					{
						$('#highlight').hide();
						$('#downLoadButtonText').show();
          $('#tableList').hide();
          $('#columnTranslationText').show();
						
					}	
  		} 
  		else 
  		{
  		  $('#highlight, #downLoadButtonText, #tableList, #columnTranslationText' ).hide(); 
  		}
  	});	

    /* CHECK TRANSLATION SELECTION 
     * & CREATE ACTION ATTIIBUTE 
     *WHEN EXPORT TEXT FORMAT IS SUBMIT
    */

    $('#exportTextFile').click(function(event){
      event.preventDefault();
      var isTranslation = false;
      if (($('#radioTrans').is(':checked') || $('#radioBoth').is(':checked')) && isTranslation == false)
      {
        $('.textTranslate').each(function(index) {
          if (!$(this).val() == '') {
            isTranslation = true;
          }
        });
        if (isTranslation == false) {
          alert('The subtitles are not translated!');
          return false; 
        }
      }

        $('#form').attr('action', 'export/');
        var actualAction = $('#form').attr('action');
        var textFormat = $("select[name=textFileType]").val();
        $('#form').attr('action', actualAction + "text/" + textFormat).submit();
   });



    /* CREATE ACTION ATTRIBUTE WHEN EXPORTS SUBS IS SUBMITED */

    $(document).on('click', '#exportSubsFile', function(event){
      event.preventDefault();
      $('#form').attr('action', 'export/');
      var actualAction = $('#form').attr('action');
      var subFormat = $("select[name=subsFileType]").val();
      if (checkErrors() == 0) {
        $('#form').attr('action', actualAction + "subs/" + subFormat).submit();
      }
    });



   /* SHOW & HIDE COORDENATES FIELDS */
   function coordinates() { 
      if ($(".subtitolIntro").val() == 'false') $('.extra').css('display', 'block');
      if ($(".subtitolIntro").val() == 'true') $('.extra').css('display', 'none');
    }

    $(document).on('change', ".subtitolIntro", function() {
      var valor = $(".subtitolIntro").val();
      if (valor == 'false') $('.extra').css('display', 'block');
      if (valor == 'true') $('.extra').css('display', 'none');
    }); 

     /* SHOW & HIDE FILE INFO IN THE EDITOR */

    //$('#fileInfo').css('display', 'none');

    $('#aInfo').click(function(event){
      $('#fileInfo').toggle();
    });


    /* SHOW & HIDE REFERENCE FILE FIELD IN EXPORT SUBS MENU */
    $(document).on('click', '#refAutoFile', function(){ 
      $('#referenceInput').slideToggle();
    });



 $(document).on('change', '#form_subtitleFile',function(){
      var cadena = $(this).val();
      var filename = cadena.replace(/C:\\fakepath\\/i, '');
    
      if (filename == '') {
        $(this).next('span').empty();
      } else {
        $(this).next('span').css({'font-style': 'italic'}).html('<i>file: ' + filename + '</i>');
      }

  }); 
     

/*LOAD SUBTITLES FORMS - AJAX*/ 

    $('#downLoadButtonSubs, #columnTranslationSubs' ).hide();

    $("select[name=subsFileType]").change(function () {
        if(this.value != "nothing") {
        var format = this.value;
        var URLnova = Routing.generate('showSubsForm', { 'subsFormat': format });
          $.ajax({  
            url: URLnova,
            dataType: 'json',
            success: function(json) {
              $('#formatTemplateSubs').empty().html(json);
              initialiseSpectrum();
              //$('#downLoadButtonSubs, #columnTranslationSubs' ).show();
            },
            error : function(jqXHR, status, error) {
              alert(error);
            }
          });

        } else {
          $('#formatTemplateSubs').empty();
          $('#downLoadButtonSubs, #columnTranslationSubs' ).hide();
        }
      
    }); 
  

    /*CHECK STLYE SETTINGS CHANGES - AJAX*/ 

    $(document).on('change', '#styleSettingsSelect', function () {
        var paramId = this.value;
        var format = $("select[name=subsFileType]").val();
        var URL = Routing.generate('parameterListContentAjax', { format: format, paramId: paramId }); 
        $.ajax({  
            url: URL,
            dataType: 'json',
            success: function(json) {
                $('#styleSettingsContainer').empty().html(json);
                coordinates();
                initialiseSpectrum();
            },
            error : function(jqXHR, status, error) {
                alert('¡Api Error! Plese, try later.');
            },
        });
    });



  //ADD PARAMETER
   $(document).on('click', '#addParam', function(){ 
        event.preventDefault();
        if (numberStyleSettingsErrors() > 0) {
            $('.dataBaseMessage').remove();
            $container = $('ul.settings').parent();
            var message = 'Before adding the preset, please correct the ' + numberStyleSettingsErrors() + ' error/s found in the form.';
            $('<span></span>').addClass('alert alert-danger dataBaseMessage').text(message).appendTo($container);
        } else { 
          var name = prompt('Please enter style settings name:');
          while (name != null && existSettingName(name) == true) {
           if ($.trim(name) == '') {
              name = prompt("The name can't be empty. Please, enter another style settings name:");
            } else {
             name = prompt("This name already exist. Please, enter another style settings name:");
            }
          }  

          if (name === null) {
      
          } 
          else { 
            var format = $("select[name=subsFileType]").val();
            var params = $("form #styleSettingsContainer input, #styleSettingsContainer select " ).serialize();
            var user =  $('#hiddenUserId').val();
            var URL = Routing.generate('addParam', { format: format, userId: user }); 
            $.ajax({  
                type: 'POST',
                url: URL,
                data: { 
                        param: params,
                        name: name,
                      },
                      dataType: 'json',
                      success: function(json) {
                          $('#styleSettingsContainer').empty().html(json);
                          coordinates();
                          initialiseSpectrum();
                      },
                      error : function(jqXHR, status, error) {
                          alert('¡Api Error! Plese, try later.');
                      },
              });
            }
          }
      });

      //DELETE PARAMETER

      $(document).on('click', '#deleteParam', function(){ 
        event.preventDefault();   
        var paramName = $('#styleSettingsSelect').find(":selected").text()
        if(confirm('Are you sure to delete the ' + paramName + ' preset?')) {
            var format = $("select[name=subsFileType]").val();
            var paramId = $('#styleSettingsSelect').val();
            var user =  $('#hiddenUserId').val();
            var URL = Routing.generate('deleteParam', { format: format, userId: user, paramId: paramId }); 

            $.ajax({  
                type: 'POST',
                url: URL,
                data: { 
                        paramName: paramName,
                      },
                      dataType: 'json',
                      success: function(json) {
                          $('#styleSettingsContainer').empty().html(json);
                          coordinates();
                          initialiseSpectrum();
                      },
                      error : function(jqXHR, status, error) {
                          alert('¡Api Error! Plese, try later.');
                      },
            });
        }
      });

      //UPDATE PARAMETER

        $(document).on('click', '#updateParam', function(){ 
        event.preventDefault();
        if (numberStyleSettingsErrors() > 0) {
            $('.dataBaseMessage').remove();
            $container = $('ul.settings').parent();
            var message = 'Before updating, please correct the ' + numberStyleSettingsErrors() + ' error/s found in the form.';
            $('<span></span>').addClass('alert alert-danger dataBaseMessage').text(message).appendTo($container);
        } else {

          var paramName = $('#styleSettingsSelect').find(":selected").text()
          if(confirm('Are you sure to update the ' + paramName + ' preset?')) {
              var format = $("select[name=subsFileType]").val();
              var params = $("form #styleSettingsContainer input, #styleSettingsContainer select " ).serialize();
              var paramId = $('#styleSettingsSelect').val();
              var user =  $('#hiddenUserId').val();
              var URL = Routing.generate('updateParam', { format: format, userId: user, paramId: paramId });  

              $.ajax({  
                  type: 'POST',
                  url: URL,
                  data: { 
                          paramName: paramName,
                          param: params,
                        },
                        dataType: 'json',
                        success: function(json) {
                            $('#styleSettingsContainer').empty().html(json);
                            coordinates();
                            initialiseSpectrum();
                        },
                        error : function(jqXHR, status, error) {
                            alert('¡Api Error! Plese, try later.');
                        },
              });
            }
          } 
        });


        //MESSAGE ALERT DISSAPEAR WHEN WE CLIK IN IT

        $(document).on('click', '.dataBaseMessage', function() {
            $(this).hide()
        });

        function existSettingName(name) {
          var response = false;
          $('#styleSettingsSelect option').each(function(index) {
              if($.trim($(this).html().toLowerCase()) === $.trim(name.toLowerCase())) {
                response = true;
              }
          }); 
          return response;
        }
      


    /* COLOR PICKER */ 
    function initialiseSpectrum() {
       $(".colorSpectrum").spectrum({
          showInput: true,
          className: "full-spectrum",
          showInitial : true,
          showPalette: true,
          showSelectionPalette: true,
          maxSelectionSize: 10,
          preferredFormat: "hex",
          localStorageKey: "spectrum.demo",
          palette: [
              ["rgb(0, 0, 0)", "rgb(67, 67, 67)", "rgb(102, 102, 102)",
              "rgb(204, 204, 204)", "rgb(217, 217, 217)","rgb(255, 255, 255)"],
              ["rgb(152, 0, 0)", "rgb(255, 0, 0)", "rgb(255, 153, 0)", "rgb(255, 255, 0)", "rgb(0, 255, 0)",
              "rgb(0, 255, 255)", "rgb(74, 134, 232)", "rgb(0, 0, 255)", "rgb(153, 0, 255)", "rgb(255, 0, 255)"], 
              ["rgb(230, 184, 175)", "rgb(244, 204, 204)", "rgb(252, 229, 205)", "rgb(255, 242, 204)", "rgb(217, 234, 211)", 
              "rgb(208, 224, 227)", "rgb(201, 218, 248)", "rgb(207, 226, 243)", "rgb(217, 210, 233)", "rgb(234, 209, 220)", 
              "rgb(221, 126, 107)", "rgb(234, 153, 153)", "rgb(249, 203, 156)", "rgb(255, 229, 153)", "rgb(182, 215, 168)", 
              "rgb(162, 196, 201)", "rgb(164, 194, 244)", "rgb(159, 197, 232)", "rgb(180, 167, 214)", "rgb(213, 166, 189)", 
              "rgb(204, 65, 37)", "rgb(224, 102, 102)", "rgb(246, 178, 107)", "rgb(255, 217, 102)", "rgb(147, 196, 125)", 
              "rgb(118, 165, 175)", "rgb(109, 158, 235)", "rgb(111, 168, 220)", "rgb(142, 124, 195)", "rgb(194, 123, 160)",
              "rgb(166, 28, 0)", "rgb(204, 0, 0)", "rgb(230, 145, 56)", "rgb(241, 194, 50)", "rgb(106, 168, 79)",
              "rgb(69, 129, 142)", "rgb(60, 120, 216)", "rgb(61, 133, 198)", "rgb(103, 78, 167)", "rgb(166, 77, 121)",
              "rgb(91, 15, 0)", "rgb(102, 0, 0)", "rgb(120, 63, 4)", "rgb(127, 96, 0)", "rgb(39, 78, 19)", 
              "rgb(12, 52, 61)", "rgb(28, 69, 135)", "rgb(7, 55, 99)", "rgb(32, 18, 77)", "rgb(76, 17, 48)"]
          ]
        });
      }

});  



















