<?php

namespace AppBundle\Controller;


use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use AppBundle\Translate\GoogleTranslate;
use Symfony\Component\HttpFoundation\JsonResponse;


class EditorController extends Controller
{
    


    /**
     * @Route("/translate", 
     *name="ajaxtranslate",   
     *options={"expose"=true},  
     *condition="request.isXmlHttpRequest()")
     */
    public function ajaxTranslateAction(Request $request)
    {
       
        $source = $request->query->get('sl');
        $target = $request->query->get('tl');
        $text = $request->query->get('q');
        $lastItem = $request->query->get('lastItem');

        
        $result = GoogleTranslate::translate($source, $target, $text); 
        $arr = ["trans" => $result, "lastItem" => $lastItem];

        return new JsonResponse($arr);

    }
}
