<?php
namespace AppBundle\Model\SubsFormat;
use AppBundle\Model\SubsFormat\Subtitle as Subtitle;


class SubtitleForText extends Subtitle{

    private $translation;
    private $highlight;


    public function __construct($id, $tcIn, $tcOut, $text, $italic, $translation, $highlight) {
        parent::__construct($id, $tcIn, $tcOut, $text, $italic);
        $this->translation = $translation;
        $this->highlight = $highlight;

    }

    public function getTranslation(){
        return $this->translation;
    }

    public function setTranslation($translation){
        $this->translation = $translation;
    }

    public function getHighlight(){
        return $this->highlight;
    }

    public function setHighlight($tcIn){
        $this->highlight = $highlight;
    }
}
